#include "stm32f10x.h"
#include "usart.h"
#include "Led.h"
#include "SysTick.h"
#include "timer.h"
#include "string.h"


//#define Buf1_Max 60 					  //1泤
#define Buf2_Max 200 					  //2泤
/*************	س	**************/
//const char *string = "AT+CSOCON=0,2678,\"116.30.216.98\"";	//IP¼
const char *string = "AT+CIPSTART=\"TCP\",\"116.30.216.98\",2678";
const char *message = "\"The TCP package send ok\n\"";   //͵Ϣ

/*************  ر	**************/
//char Uart1_Buf[Buf1_Max];
char Uart2_Buf[Buf2_Max];

u8 Times=0,First_Int = 0,shijian=0;
u16 Heartbeat=0;

vu8 Timer0_start;	//ʱ0ʱ
vu8 Uart2_Start;	//2ʼ
vu8 Uart2_End;	  //2ݽ
vu8 Heart_beat;		//֡־λ

/*************	غ	**************/
void CLR_Buf2(void);
u8 Find(char *a);
void Second_AT_Command(char *b,char *a,u8 wait_time);
void Set_ATE0(void);
void Connect_Server(void);
void Disconnect_Server(void);
void Rec_Server_Data(void);
void Wait_CREG(void);
void Send_OK(void);

/*************  ⲿͱ*****************/




/*******************************************************************************
*  : main 
*    : 
*    : 
*    : 
*    : 
* ע   : 2CP2102ģͨţ1ڴڵԣԱسʱ
					 ͵ģ
*******************************************************************************/
int main(void)
{
	u8 num;
	SysTick_Init_Config();
	GPIO_Config();

	USART1_Init_Config(115200);
	USART2_Init_Config(115200);
	Timer2_Init_Config();
	UART1_SendString("SIM7000 NB-IoT Test Demo\r\n");
	UART1_SendString("Registering network\r\n");
	Wait_CREG();
	UART1_SendString("Registration success\r\n");
	UART1_SendString("Connect to the server\r\n");
	Set_ATE0();
	Connect_Server();
	UART1_SendString("Connection success\r\n");
	for(num=0;num<3;num++)
	{
		//Rec_Server_Data();
		
		//if(Heart_beat)
		//{
			Send_OK();
			//Heart_beat=0;
			UART1_SendString("Send success!\r\n");
		//}
	}
	Disconnect_Server();
	UART1_SendString("Disconnect server success!\r\n");
}

/*******************************************************************************
*   : USART2_IRQHandler
*     : 1жϷ
*     : 
*     :  
* ˵    : 
*******************************************************************************/
void USART2_IRQHandler(void)                	
{
			u8 Res=0;
			Res =USART_ReceiveData(USART2);
			Uart2_Buf[First_Int] = Res;  	  //յַ浽
			First_Int++;                			//ָƶ
			if(First_Int > Buf2_Max)       		//,ָָ򻺴׵ַ
			{
				First_Int = 0;
			}    
} 	

/*******************************************************************************
*   : TIM2_IRQHandler
*     : ʱ2ж϶Ϸ
*     : 
*     : 
*     :  
* ˵    : 
*******************************************************************************/
void TIM2_IRQHandler(void)   //TIM3ж
{
	static u8 flag =1;

	if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)  //TIM3жϷ
	{
		
		TIM_ClearITPendingBit(TIM2, TIM_IT_Update  );  //TIMxжϱ־ 
		
		if(Timer0_start)
		Times++;
		if(Times > shijian)
		{
			Timer0_start = 0;
			Times = 0;
		}
		
		Heartbeat++;
		if(Heartbeat>9)//ÿ10뷢֡
		{
			Heartbeat=0;
			Heart_beat=1;
		}
		if(flag)
		{
			LED4_ON(); 
			flag=0;
		}
		else
		{
			LED4_OFF(); 
			flag=1;
		}
	}	
}

/*******************************************************************************
*  : CLR_Buf2
*    : 2
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void CLR_Buf2(void)
{
	u16 k;
	for(k=0;k<Buf2_Max;k++)      //
	{
		Uart2_Buf[k] = 0x00;
	}
    First_Int = 0;              //ַʼ洢λ
}

/*******************************************************************************
*  : Find
*    : жϻǷַָ
*    : 
*    : 
*    : unsigned char:1 ҵַָ0 δҵַָ 
* ע   : 
*******************************************************************************/

u8 Find(char *a)
{ 
  if(strstr(Uart2_Buf,a)!=NULL)
	    return 1;
	else
			return 0;
}

/*******************************************************************************
*  : Second_AT_Command
*    : ATָ
*    : ݵָ롢͵ȴʱ(λS)
*    : 
*    : 
* ע   : 
*******************************************************************************/

void Second_AT_Command(char *b,char *a,u8 wait_time)         
{
	u8 i;
	char *c;
	c = b;										//ַַc
	CLR_Buf2(); 
  i = 0;
	while(i == 0)                    
	{
		if(!Find(a)) 
		{
			if(Timer0_start == 0)
			{
				b = c;							//ַַb
				for (; *b!='\0';b++)
				{
					while(USART_GetFlagStatus(USART2, USART_FLAG_TC)==RESET);
					USART_SendData(USART2,*b);//UART2_SendData(*b);
				}
				UART2_SendLR();	
				Times = 0;
				shijian = wait_time;
				Timer0_start = 1;
		   }
    }
 	  else
		{
			i = 1;
			Timer0_start = 0;
		}
	}
	CLR_Buf2(); 
}

/*******************************************************************************
*  : Wait_CREG
*    : ȴģעɹ
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Wait_CREG(void)
{
	u8 i;
	u8 k;
	i = 0;
	CLR_Buf2();
  while(i == 0)        			
	{
		CLR_Buf2();        
		UART2_SendString("AT+CGREG?");
		UART2_SendLR();
		Delay_nMs(5000);  						
	    for(k=0;k<Buf2_Max;k++)      			
    	{
				if(Uart2_Buf[k] == ':')
			{
				if((Uart2_Buf[k+4] == '1')||(Uart2_Buf[k+4] == '5'))
				{
					i = 1;
					UART1_SendLR();
				  break;
				}else if(Uart2_Buf[k+4] == '2')
				{
					UART1_SendString("Waiting...");
				}
			}
		}	
		UART1_SendString("Registering...");
		
	}
}

/*******************************************************************************
*  : Set_ATE0
*    : ȡ
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Set_ATE0(void)
{
	Second_AT_Command("ATE0","OK",3);								//ȡ		
}
/*******************************************************************************
*  : Connect_Server
*    : GPRSӷ
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Connect_Server(void)
{
    Second_AT_Command("AT+CSTT=\"CMNET\"","OK",5); //ʵAPNƶΪ
    Second_AT_Command("AT+CIICR","OK",5);          //ƶ
    Second_AT_Command((char*)string,"OK",10);      //ӷ
    Second_AT_Command("AT+CIPSEND=26",">",5);      //ָ
	Delay_nMs(100);

	CLR_Buf2();
}

/*******************************************************************************
*  : Connect_Server
*    : GPRSӷ
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Disconnect_Server(void)
{
	Second_AT_Command("AT+CSOCL=0","OK",2);//رTCP socket
}
/*******************************************************************************
*  : Rec_Server_Data
*    : շݺ
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Rec_Server_Data(void)
{
	if(strstr(Uart2_Buf,"+CSONMI")!=NULL)   		//ַк^SISR
	{	
		Heartbeat=0;	//֡
		Heart_beat=0;
		Delay_nMs(100);
/*		if(strstr(Uart2_Buf,"onled")!=NULL)
		{
			LED1_ON();
		}
		else if(strstr(Uart2_Buf,"offled")!=NULL)
		{
			LED1_OFF();
		}*/
		UART1_SendString("New message:\r\n");
		UART1_SendString(Uart2_Buf);
		CLR_Buf2();
		Heart_beat=1;//Ӧݣ߷յ		
	}
}
/*******************************************************************************
*  : Send_OK
*    : Ӧָú
					1յݺӦ
					2·ʱÿ10뷢һ֡
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Send_OK(void)
{
    Second_AT_Command((char*)message,"OK",20);      //
	Delay_nMs(5000);
}
